<?php
/*
Plugin Name: Dramatars
Plugin URI: http://dramatar.com/
Description: Use Dramatars on your site and get dramatic! You can select from several styles of avatars, including Spirograph, Abstracts, Arcs and Boxes. Many more fun avatars are planned! You can also use Gravatars as your avatars and fall back to Dramatars as the default if the user doesn't have any Gravatar set.
Version: 0.4.2
Author: Dramatar.com
Author URI: http://dramatar.com/

Copyright (C) 2011  Rocket Full, Ltd. Co.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
class dramatar {
	var $dramatar_version = "0.4";
	var $url = 'http://dramatar.com/wordpress.png';
	var $dramatar_types = array('spirograph','abstract','arc','boxy','ragdoll','anime');
	function dramatar( ) {
		add_filter( 'avatar_defaults' , array( &$this , 'adddramatar' ) );
		add_filter( 'get_avatar', array( &$this, 'showdramatar' ), 10, 5 );
		add_action('admin_menu', array( &$this , 'add_dramatar_option_page') );
		add_action('admin_init', array( &$this , 'dramatar_init_action') );
	}
	function dramatar_init_action() {
		register_setting('dramatar_options_group', 'dramatar_options', array( &$this , 'dramatar_validate_options') );
	}
	function dramatar_validate_options($input) {
		$options = get_option('dramatar_options');
		// Customization options:
		$options['support_given'] = $input['support_given'];
		$options['avatar'] = $input['avatar'];
		$options['no_gravatars'] = $input['no_gravatars'];
		return $options;
	}
	function adddramatar ( $avatar_defaults ) {
		$options = get_option('dramatar_options', array('avatar'=>'spirograph') );
		$dramatarhtml = '<label for="dramatar_type">Dramatar <a href="options-general.php?page=dramatars/dramatars.php" title="Configure Your Dramatars">(Generated '.ucfirst($options['avatar']).')</a></label>';
		$avatar_defaults[ $this->url ] = $dramatarhtml;
		return $avatar_defaults;
	}
	function showdramatar( $avatar, $id_or_email, $size, $default, $alt ) {
		if ( strpos( $default, $this->url ) !== false ) {
			$options = get_option('dramatar_options', array('avatar'=>'spirograph') );
			if ( is_object( $id_or_email ) ) $email = $id_or_email->comment_author_email; 
			else $email = $id_or_email;
			$email = empty( $email ) ? 'nobody' : md5( $email );
			// This is for the Dramatar.com website. It forces Dramatar types to display based on
			// the type set in this cookie. It's not a live option, so if you want to use it, you need to 
			// code something to set the cookie on your site. 
			if ($_COOKIE['type']) { $options['avatar'] = $_COOKIE['type']; }
			// end
			$avatar = str_replace( 'wordpress.png', 'avatar/'.$options['avatar'].'/'.$email.'.png', $avatar );
			if ($options['no_gravatars']) {
				$avatar = str_replace( 'r=', 'f=y&r=', $avatar );
			}
		}
		return $avatar;
	}	

	function add_dramatar_option_page() {
		add_options_page('Dramatar', 'Dramatars', 4, __FILE__, array( &$this , 'dramatar_options_page') );
	}

	function dramatar_options_page() {
		$options = get_option('dramatar_options', array('avatar'=>'spirograph') );
		$default = get_option('avatar_default');
		?>

		<div class="wrap">
			<div class="icon32" id="icon-options-general"><br></div>
			<h2>Dramatar Display Options
				<form style="display:inline; margin-left:1em" target="_blank" action="https://www.paypal.com/cgi-bin/webscr" method="post">
				<input type="hidden" name="cmd" value="_s-xclick">
				<input type="hidden" name="hosted_button_id" value="E2C3EM6HFF3TQ">
				<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donate_SM.gif" border="0" name="submit" alt="Help support the Dramatar project. Dontate today!">
				<!--<img alt="" border="0" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" width="1" height="1">-->
				</form>
			</h2>
			<?php if ($default != 'http://dramatar.com/wordpress.png') { ?><div id="dramatar-warning" class="updated fade"><p><strong>Dramatars are not enabled.</strong> You must <a href="options-discussion.php">enable Dramatars</a> under the Avatar section of Discussion Settings page.</p></div>			<?php } ?>


			<div id="dramatar-selection" style="width:500px;display:inline-block;vertical-align: top;">
				<h3>Dramatar Selection</h3>
				<div style="padding-left:15px;">
				<form method="post" action="options.php">
					<?php /*wp_nonce_field('update-options'); 
					<input type="hidden" name="page_options" value="dramatar_support_given">
					<input type="hidden" name="action" value="update">	*/?>

					<?php settings_fields('dramatar_options_group'); ?>

					<fieldset><legend class="screen-reader-text"><span>Select a Dramatar</span></legend>You can choose any type of Dramatar you want!<br>
					<?php foreach ($this->dramatar_types as $type) {
						echo '<label><input type="radio" name="dramatar_options[avatar]" id="avatar_'.$type.'" value="'.$type.'"';
						if ($options['avatar'] == $type) { echo ' checked'; }
						echo '> <img alt="'.ucfirst($type).' Dramatar" src="http://dramatar.com/avatar/'.$type.'/00000000000000000000000000000000.png?s=32" class="avatar avatar-32 photo" height="32" width="32" style="vertical-align: middle;padding:3px 0;"> '.ucfirst($type).'</label><br>';
					} ?>
					</fieldset>

					<div style="padding-top:20px;"><input type="checkbox" name="dramatar_options[no_gravatars]" value="true"<?php if ($options['no_gravatars']=="true"){echo ' checked="checked"';}?>> Do not display Gravatars first.</div>

					<div style="padding-top:20px;"><input type="checkbox" name="dramatar_options[support_given]" value="true"<?php if ($options['support_given']=="true"){echo ' checked="checked"';}?>> I have donated to Dramatar!</div>

					<p class="submit"><input type="submit" class="button-primary" value="Save Avatar"></p>
				</form>
				</div>


				<h3>Spread the Love!</h3>
				<div style="padding-left:15px;">
					<div style="padding-bottom:10px;">Do you love Dramatars but just can't donate to the project? That's ok, we still love you! If you'd like to show some appriciation you can like is on Facebook, +1 us on Google Plus, Tweet about us or just tell your friends.</div>

					<div style="width:80px;display:inline;float: left;">
					<!-- Place this tag where you want the +1 button to render -->
					<g:plusone size="tall" href="http://dramatar.com"></g:plusone>
					<!-- Place this render call where appropriate -->
					<script type="text/javascript">
					  (function() {
					    var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;
					    po.src = 'https://apis.google.com/js/plusone.js';
					    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);
					  })();
					</script>
					</div>
					<div style="width:80px;display:inline;float: left;">
						<a href="http://twitter.com/share" class="twitter-share-button" data-url="http://dramatar.com" data-text="Dramatars: Your dramatic, dynamic avatar!" data-count="vertical">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script>
					</div>
					<div style="width:80px;display:inline;float: left;">
						<div id="fb-root"></div><script src="http://connect.facebook.net/en_US/all.js#appId=255101081190023&amp;xfbml=1"></script><fb:like href="http://www.facebook.com/pages/Dramatar/155633851188118" send="true" layout="box_count" width="500" show_faces="false" font="verdana"></fb:like>
					</div>
				</div>
			</div><!--/#dramatar-selection -->

			<div id="dramatar-news" style="width:400px;display:inline-block;vertical-align: top;">
				<h3>Recent News</h3>
				<div style="padding-left:15px;">
				<?php
				// Show the last 5 news items.
				$curl = curl_init();
				curl_setopt($curl, CURLOPT_URL, "http://dramatar.com/pages/feed");
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 0);
				$xmlDrama = curl_exec($curl);
				curl_close($curl);
				$xmlObjDrama = simplexml_load_string( $xmlDrama );
				$tempCounter = 0; 
				foreach ( $xmlObjDrama->channel->item as $item ) {                    
					if ( $tempCounter < 6 ) {
						echo "<li><a href=\"{$item->guid}\">{$item->title}</a><br>{$item->description}</li>\n";
					}
					$tempCounter += 1;
				}
				?>
				</div>
			</div><!--/#dramatar-news -->
		</div><!-- /.wrap -->
		<?php
	}
}

new dramatar( );